tbb::flow::interface11::receiver< T > Class Template Referenceabstract

Pure virtual template class that defines a receiver of messages of type T. More...

`#include <flow_graph.h>`

Inheritance diagram for tbb::flow::interface11::receiver< T >:
Collaboration diagram for tbb::flow::interface11::receiver< T >:

## Public Member Functions

bool | try_put (const typename internal::async_helpers< T >::filtered_type &t)
| Put an item to the receiver. More...
bool | try_put (const typename internal::async_helpers< T >::async_type &t)
Public Member Functions inherited from tbb::flow::interface11::internal::untyped_receiver
virtual | ~untyped_receiver ()
| Destructor. More...
template<typename X >
bool | try_put (const X &t)
| Put an item to the receiver. More...
virtual bool | register_predecessor (predecessor_type &)
| Add a predecessor to the node. More...
virtual bool | remove_predecessor (predecessor_type &)
| Remove a predecessor from the node. More...

## Public Attributes

__TBB_DEPRECATED typedef T | input_type
| The input type of this receiver. More...
__TBB_DEPRECATED typedef internal::async_helpers< T >::filtered_type | filtered_type

## Protected Member Functions

virtual task * | try_put_task_wrapper (const void *p, bool is_async) __TBB_override
virtual task * | try_put_task (const T &t)=0
| Put item to successor; return task to run the successor if possible. More...
Protected Member Functions inherited from tbb::flow::interface11::internal::untyped_receiver
template<typename X >
task * | try_put_task (const X &t)
virtual graph & | graph_reference () const =0
virtual void | reset_receiver (reset_flags f=rf_reset_protocol)=0
| put receiver back in initial state More...
virtual bool | is_continue_receiver ()

## Friends

template<typename >
class | internal::async_storage
template<typename , typename >
struct | internal::async_helpers

## Additional Inherited Members

Public Types inherited from tbb::flow::interface11::internal::untyped_receiver
typedef untyped_sender | predecessor_type
| The predecessor type for this node. More...

## Detailed Description

### template<typename T>
class tbb::flow::interface11::receiver< T >

Pure virtual template class that defines a receiver of messages of type T.

Definition at line 462 of file flow_graph.h.

## Member Function Documentation

## try_put() [1/2]

template<typename T >

bool tbb::flow::interface11::receiver< T >::try_put | ( | const typename internal::async_helpers< T >::async_type & | t | ) |

inline

Definition at line 476 of file flow_graph.h.

{
return internal::untyped_receiver::try_put(t);
}
tbb::flow::interface11::internal::untyped_receiver::try_put
bool try_put(const X &t)
Put an item to the receiver.
Definition: flow_graph.h:377

References tbb::flow::interface11::internal::untyped_receiver::try_put().

Here is the call graph for this function:

## try_put() [2/2]

template<typename T >

bool tbb::flow::interface11::receiver< T >::try_put | ( | const typename internal::async_helpers< T >::filtered_type & | t | ) |

inline

Put an item to the receiver.

Definition at line 472 of file flow_graph.h.

{
return internal::untyped_receiver::try_put(t);
}

References tbb::flow::interface11::internal::untyped_receiver::try_put().

Here is the call graph for this function:

## try_put_task()

template<typename T >

virtual task* tbb::flow::interface11::receiver< T >::try_put_task | ( | const T & | t | ) |

protected pure virtual

Put item to successor; return task to run the successor if possible.

Implemented in tbb::flow::interface11::split_node< TupleType, Allocator >, tbb::flow::interface11::write_once_node< T >, tbb::flow::interface11::limiter_node< T, DecrementType >, tbb::flow::interface11::buffer_node< T, Allocator >, tbb::flow::interface11::buffer_node< T, __TBB_DEFAULT_NODE_ALLOCATOR(T) >, tbb::flow::interface11::broadcast_node< T >, and tbb::flow::interface11::overwrite_node< T >.

Referenced by tbb::flow::interface11::internal::async_helpers< T, typename >::try_put_task_wrapper_impl(), and tbb::flow::interface11::internal::async_helpers< T, typename std::enable_if< std::is_base_of< async_msg< typename T::async_msg_data_type >, T >::value >::type >::try_put_task_wrapper_impl().

Here is the caller graph for this function:

## try_put_task_wrapper()

template<typename T >

virtual task* tbb::flow::interface11::receiver< T >::try_put_task_wrapper | ( | const void * | p,
|  | bool | is_async
| ) |  |

inline protected virtual

Implements tbb::flow::interface11::internal::untyped_receiver.

Definition at line 481 of file flow_graph.h.

{
return internal::async_helpers<T>::try_put_task_wrapper_impl(this, p, is_async);
}
p
void const char const char int ITT_FORMAT __itt_group_sync p
Definition: ittnotify_static.h:91
tbb::flow::interface11::internal::async_helpers::try_put_task_wrapper_impl
static task * try_put_task_wrapper_impl(receiver< T > *const this_recv, const void *p, bool is_async)
Definition: flow_graph.h:245

References p, and tbb::flow::interface11::internal::async_helpers< T, typename >::try_put_task_wrapper_impl().

Here is the call graph for this function:

## Friends And Related Function Documentation

## internal::async_helpers

template<typename T >
template<typename , typename >

friend struct internal::async_helpers

friend

Definition at line 464 of file flow_graph.h.

## internal::async_storage

template<typename T >
template<typename >

friend class internal::async_storage

friend

Definition at line 463 of file flow_graph.h.

## Member Data Documentation

## filtered_type

template<typename T >

__TBB_DEPRECATED typedef internal::async_helpers<T>::filtered_type tbb::flow::interface11::receiver< T >::filtered_type

Definition at line 469 of file flow_graph.h.

## input_type

template<typename T >

__TBB_DEPRECATED typedef T tbb::flow::interface11::receiver< T >::input_type

The input type of this receiver.

Definition at line 467 of file flow_graph.h.

The documentation for this class was generated from the following file:

- flow_graph.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.